
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProductsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.create(
            {
                id: data.id || undefined,
        
        product_title: data.product_title
        ||
        null
            ,
            
        handle: data.handle
        ||
        null
            ,
            
        vendor: data.vendor
        ||
        null
            ,
            
        product_type: data.product_type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        is_featured_top3: data.is_featured_top3
        ||
        false
        
            ,
            
        current_sales_rank: data.current_sales_rank
        ||
        null
            ,
            
        total_sales_count: data.total_sales_count
        ||
        null
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await products.setStore( data.store || null, {
            transaction,
        });
        
        await products.setCollection( data.collection || null, {
            transaction,
        });
        
        await products.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                product_title: item.product_title
            ||
            null
            ,
            
                handle: item.handle
            ||
            null
            ,
            
                vendor: item.vendor
            ||
            null
            ,
            
                product_type: item.product_type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                is_featured_top3: item.is_featured_top3
            ||
            false
        
            ,
            
                current_sales_rank: item.current_sales_rank
            ||
            null
            ,
            
                total_sales_count: item.total_sales_count
            ||
            null
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const products = await db.products.bulkCreate(productsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < products.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.products.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: products[i].id,
                },
                data[i].images,
                options,
            );
        }
        

        return products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const products = await db.products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.product_title !== undefined) updatePayload.product_title = data.product_title;
        
        
        if (data.handle !== undefined) updatePayload.handle = data.handle;
        
        
        if (data.vendor !== undefined) updatePayload.vendor = data.vendor;
        
        
        if (data.product_type !== undefined) updatePayload.product_type = data.product_type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.is_featured_top3 !== undefined) updatePayload.is_featured_top3 = data.is_featured_top3;
        
        
        if (data.current_sales_rank !== undefined) updatePayload.current_sales_rank = data.current_sales_rank;
        
        
        if (data.total_sales_count !== undefined) updatePayload.total_sales_count = data.total_sales_count;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await products.update(updatePayload, {transaction});

        
        
        if (data.store !== undefined) {
            await products.setStore(
              
              data.store,
              
              { transaction }
            );
        }
        
        if (data.collection !== undefined) {
            await products.setCollection(
              
              data.collection,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await products.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of products) {
                await record.destroy({transaction});
            }
        });


        return products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findByPk(id, options);

        await products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await products.destroy({
            transaction
        });

        return products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findOne(
            { where },
            { transaction },
        );

        if (!products) {
            return products;
        }

        const output = products.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.product_variants_product = await products.getProduct_variants_product({
            transaction
        });
        
        
        
        
        
        output.order_items_product = await products.getOrder_items_product({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.store = await products.getStore({
            transaction
        });
        
        
        output.collection = await products.getCollection({
            transaction
        });
        
        
        output.images = await products.getImages({
            transaction
        });
        
        
        output.organizations = await products.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stores,
        as: 'store',
        
        where: filter.store ? {
          [Op.or]: [
            { id: { [Op.in]: filter.store.split('|').map(term => Utils.uuid(term)) } },
            {
              store_name: {
                [Op.or]: filter.store.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.collections,
        as: 'collection',
        
        where: filter.collection ? {
          [Op.or]: [
            { id: { [Op.in]: filter.collection.split('|').map(term => Utils.uuid(term)) } },
            {
              collection_name: {
                [Op.or]: filter.collection.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.product_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'product_title',
                        filter.product_title,
                    ),
                };
            }
            
            if (filter.handle) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'handle',
                        filter.handle,
                    ),
                };
            }
            
            if (filter.vendor) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'vendor',
                        filter.vendor,
                    ),
                };
            }
            
            if (filter.product_type) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'product_type',
                        filter.product_type,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.current_sales_rankRange) {
                const [start, end] = filter.current_sales_rankRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_sales_rank: {
                    ...where.current_sales_rank,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_sales_rank: {
                    ...where.current_sales_rank,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_sales_countRange) {
                const [start, end] = filter.total_sales_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_sales_count: {
                    ...where.total_sales_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_sales_count: {
                    ...where.total_sales_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.is_featured_top3) {
                where = {
                    ...where,
                is_featured_top3: filter.is_featured_top3,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'products',
                        'product_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.products.findAll({
            attributes: [ 'id', 'product_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['product_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.product_title,
        }));
    }

    
};

